﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;

namespace XamDataGridSearchEngine
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			this.InitializeComponent();
            xamDataGrid1.DataSource = new LibraryBusinessLogic().Categories;
		}



	}

    public class XamDataGridEx : XamDataGrid, INotifyPropertyChanged
    {
        Label filters;
        
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            filters = GetTemplateChild("filters") as Label;

            Style labelStyle =  new Style(typeof(LabelPresenter));
            labelStyle.Setters.Add(new EventSetter(LabelPresenter.LoadedEvent,
               new RoutedEventHandler(
                   (s, e) =>
                   {
                       LabelPresenter presenter = s as LabelPresenter;
                       string key = presenter.Field.Label.ToString();
                       if(!Labels.ContainsKey(key))
                            Labels.Add(key, presenter);  
                       presenter.ToString();
                   })));
            Resources.Add(typeof(LabelPresenter), labelStyle);
        }

        protected override void OnRecordFilterChanged(Infragistics.Windows.DataPresenter.Events.RecordFilterChangedEventArgs args)
        {
            base.OnRecordFilterChanged(args);

            string results = string.Empty;

            foreach (FieldLayout layout in this.FieldLayouts)
            {
                foreach (RecordFilter filter in layout.RecordFilters)
                {
                    if (filter.Conditions.Count > 0)
                    {
                        results += filter.FieldName + ",";
                    }
                }
            }
            if (filters != null)
                filters.Content = "Filtered Fields: " + results;
        }


        private bool flag;
        public bool CellColoringBindingTrigger
        {
            get { return flag; }
            set { flag = value; if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs("CellColoringBindingTrigger")); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private Dictionary<string, LabelPresenter> myVar = new Dictionary<string, LabelPresenter>();

        public Dictionary<string,LabelPresenter> Labels
        {
            get { return myVar; }
        }

    }

    public class CellMatchConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            CellValuePresenter cPresenter = values[0] as CellValuePresenter;
            DataRecord rec = values[1] as DataRecord;
            if (cPresenter.Field != null && rec != null)
            {
               
                return rec.Cells[cPresenter.Field].Tag;

            }

            return "";
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}